=== debian/changelog ===
apron (0.9.10-9build4) bionic; urgency=medium

  * No-change rebuild for mpfr soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 24 Jan 2018 21:19:24 +0000

apron (0.9.10-9build3) bionic; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 27 Oct 2017 21:54:32 +0200

apron (0.9.10-9build2) artful; urgency=high

  * No change rebuild against ocaml 4.04.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 27 Jun 2017 13:37:33 +0100

apron (0.9.10-9build1) zesty; urgency=medium

  * No-change rebuild against latest ppl

 -- Jeremy Bicha <jbicha@ubuntu.com>  Fri, 16 Dec 2016 20:54:41 -0500

apron (0.9.10-9) unstable; urgency=medium

  * Team upload.
  * Make libapron-dev depend on libapron (Closes: #715070)
  * Bump Standards-Version to 3.9.8
  * debian/control: Use canonical, HTTPS URLs
  * debian/copyright: Update
    - Switch to fomat 1.0
    - Fix syntax errors
    - Fix license information on some files
  * debian/rules: Fail on non-installed files
  * Use build-time hardening
  * Install all shlib symlinks in libapron-dev
    This required a package transition
  * Fix typos in documentation & binaries
    Add patch 0010-Fix-typos.patch
  * Add doc-base files

 -- Nicolas Braud-Santoni <nicolas@braud-santoni.eu>  Wed, 03 Aug 2016 16:47:13 +0200

apron (0.9.10-8) unstable; urgency=medium

  * Team upload
  * Fix package-build with -A, by letting dh install the lintian override
    (Closes: #805993). Thanks to Santiago Vila for the patch

 -- Ralf Treinen <treinen@debian.org>  Thu, 14 Jul 2016 20:13:56 +0200

apron (0.9.10-7) unstable; urgency=medium

  * Team upload.
  * Fix build with GCC 5 by not defining strdup (Closes: #808628).
    - Add patch 0009-Don-t-define-strdup.patch

 -- Mehdi Dogguy <mehdi@debian.org>  Sun, 17 Jan 2016 23:25:59 +0100

apron (0.9.10-6) unstable; urgency=low

  [ Stéphane Glondu ]
  * Team upload
  * Acknowledge non-maintainer uploads
  * debian/control:
    - bump debhelper compat level to 9
    - update Vcs-*
    - remove leading articles from short descriptions
    - remove Samuel and myself from Uploaders

  [ Matthias Klose ]
  * Fix build failure with ppl-1.0 (Closes: #707347)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 25 Dec 2013 13:00:39 +0100

apron (0.9.10-5.2) unstable; urgency=low

  * Follow-on NMU to fix the binary dependency on libppl0.10-dev.
    Really Closes: #620716.

 -- Steve Langasek <vorlon@debian.org>  Sun, 10 Apr 2011 09:38:37 +0000

apron (0.9.10-5.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build-depend on the libppl-dev virtual package instead of libppl0.10-dev,
    since this latter package is no longer available in unstable and apron
    now fails to build.  Closes: #620716.

 -- Steve Langasek <vorlon@debian.org>  Sun, 10 Apr 2011 01:22:13 +0000

apron (0.9.10-5) unstable; urgency=low

  * Add mpfr_random.diff and rounding_modes.diff (Closes: #589359)
  * debian/control:
    - add myself to Uploaders
    - bump Standards-Version to 3.9.0
  * Install upstream changelog
  * Switch source package format to 3.0 (quilt)

 -- Stéphane Glondu <glondu@debian.org>  Mon, 19 Jul 2010 13:22:45 +0200

apron (0.9.10-4) unstable; urgency=low

  [ Mehdi Dogguy ]
  * Remove non-needed Provides for libapron-dev
  * Version the build dependency on quilt: >= 0.46-7

  [ Samuel Mimram ]
  * Added link patch in order to resolve symbols, closes: #558838.
  * Fix nonopt patch to build gmp.cmxa.
  * Added oct_static patch in order to install oct*.a.

 -- Samuel Mimram <smimram@debian.org>  Sun, 17 Jan 2010 17:57:33 +0100

apron (0.9.10-3) unstable; urgency=low

  * Remove build dependency on ocaml-native-compilers, closes: #556636.

 -- Samuel Mimram <smimram@debian.org>  Tue, 17 Nov 2009 17:53:40 +0100

apron (0.9.10-2) unstable; urgency=low

  * Enable PPL support.
  * Add nonopt patch in order to be able to build on non-native archs.

 -- Samuel Mimram <smimram@debian.org>  Thu, 29 Oct 2009 21:58:00 +0100

apron (0.9.10-1) unstable; urgency=low

  * Initial release, closes: #552326.

 -- Samuel Mimram <smimram@debian.org>  Wed, 21 Oct 2009 19:06:36 +0200
