=== debian/control ===
Source: apron
Section: libdevel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Build-Depends:
 debhelper (>= 9),
 ocaml-nox (>= 3.11.1-3~),
 ocaml-best-compilers,
 camlidl,
 dh-ocaml (>= 0.9~),
 libgmp3-dev,
 libmpfr-dev,
 libppl-dev,
 texi2html (>= 1.82)
Standards-Version: 3.9.8
Homepage: http://apron.cri.ensmp.fr/library/
Vcs-Git: https://anonscm.debian.org/git/pkg-ocaml-maint/packages/apron.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ocaml-maint/packages/apron.git

Package: libapron
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: runtime libraries for APRON
 The APRON library is dedicated to the static analysis of the numerical
 variables of a program by Abstract Interpretation. The aim of such an analysis
 is to infer invariants about these variables. It is intended to be a common
 interface to various underlying libraries/abstract domains and to provide
 additional services that can be implemented independently from the underlying
 library/abstract domain.
 .
 This package contains the shared libraries needed at runtime.

Package: libapron-dev
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends},
 libapron,
 libgmp3-dev,
 libmpfr-dev,
 libppl-dev
Description: abstract interpretation library
 The APRON library is dedicated to the static analysis of the numerical
 variables of a program by Abstract Interpretation. The aim of such an analysis
 is to infer invariants about these variables. It is intended to be a common
 interface to various underlying libraries/abstract domains and to provide
 additional services that can be implemented independently from the underlying
 library/abstract domain.
 .
 This package contains the files necessary to use the APRON library in C.

Package: libapron-ocaml
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}
Provides: ${ocaml:Provides}
Description: runtime libraries for APRON (OCaml interface)
 The APRON library is dedicated to the static analysis of the numerical
 variables of a program by Abstract Interpretation. The aim of such an analysis
 is to infer invariants about these variables. It is intended to be a common
 interface to various underlying libraries/abstract domains and to provide
 additional services that can be implemented independently from the underlying
 library/abstract domain.
 .
 This package include only the dynamic libraries needed for running dynamic
 bytecode executables.

Package: libapron-ocaml-dev
Section: ocaml
Architecture: any
Depends: ${ocaml:Depends}, ${shlibs:Depends}, ${misc:Depends}, libapron-dev
Provides: ${ocaml:Provides}
Description: abstract interpretation library (OCaml interface)
 The APRON library is dedicated to the static analysis of the numerical
 variables of a program by Abstract Interpretation. The aim of such an analysis
 is to infer invariants about these variables. It is intended to be a common
 interface to various underlying libraries/abstract domains and to provide
 additional services that can be implemented independently from the underlying
 library/abstract domain.
 .
 This package contains the files necessary to use the APRON library in OCaml.
