=== debian/watch ===
version=3
http://apron.cri.ensmp.fr/library/ apron-([0-9]\..*)\.tgz
